%% Volpano other type systems, from Concrete semantics

% standard type system fig 9.8 with antimono in and max out

%% bug 1: inversion of less in antimono

pred sectyD (level,sectx,cmd).

sectyD(_,_,skip).

sectyD(L,T,assn(X,A)) :- 
  exists LX. lookup(T,X,LX), 
  exists LA. asec(A, T, LA), 
  le(LA,LX), le(L,LX).

sectyD(L,T,seq(C1,C2)) :- 
  sectyD(L,T,C1),sectyD(L,T,C2).

sectyD(L,T,ift(B,C1,C2)) :- 
  exists Lb. bsec(B,T, Lb), 
  le(Lb,L),
  sectyD(Lb,T, C1),
  sectyD(Lb,T, C2).

sectyD(L,T,whi(B,C)) :- 
  exists Lb. bsec(B,T, Lb),
  le(Lb,L),
  sectyD(Lb   ,T, C).

sectyD(L',T,C) :-  
  sectyD(L,T,C),
  le(L, L'). %% BUG! was   le(L', L)

%% bottom up typing

pred sectyBUP (level,sectx,cmd).

% mode of sectyBUP(-L,+T,C)
sectyBUP(_,_,skip).


sectyBUP(LX,T,assn(X,A)) :- 
  exists LX. lookup(T,X,LX), 
  exists LA. asec(A, T, LA), 
  le(LA,LX).

sectyBUP(LMIN,T,seq(C1,C2)) :- 
    exists L1. sectyBUP(L1,T,C1),
    exists L2. sectyBUP(L2,T,C2),
    min(L1,L2,LMIN).

sectyBUP(LMIN,T,ift(B,C1,C2)) :- 
  exists L1. sectyBUP(L1,T, C1),
	     exists L2. sectyBUP(L2,T, C2),
			exists Max. min(L1,L2,LMIN),
				    exists Lb. bsec(B,T, Lb),
					       le(Lb,LMIN).
			 


sectyBUP(L,T,whi(B,C)) :-
    exists Lb. bsec(B,T, Lb), le(Lb,L),
    sectyBUP(L,T, C).



(*
 Nitpick on ty-tyD we *cannot* find

	
    c = WHILE bexp.Not (Less (N 1) (V [c⇩1])) DO [c⇩1] ::= N 1
    l = 0 


tyD-ty	   

 aprolog -check-nf -v imp.apl volpano.apl moretypes-bug1.apl check-ty-nf.apl 
 NF to prop 1

    Total: 0.24 s:
C = assn(X330986,c(sc(sc(sc(sc(z)))))) 
L = sc(sc(sc(sc(sc(sc(z)))))) 
T = [(X330986,sc(sc(sc(sc(z)))))]

aprolog -check-ne-simpl imp.apl volpano.apl moretypes-bug1.apl check-ty-ne.apl

Checking tyD-imp-ty
depth 7 Total: 0.304678 s:
C = assn(X264397,c(N264420)) 
L = sc(X265008) 
T = [(X264397,z)|_264402] 

 *)
