%% Volpano other type systems, from Concrete semantics

% standard type system fig 9.8 with antimono in and max out

pred sectyD (level,sectx,cmd).

sectyD(_,_,skip).

sectyD(L,T,assn(X,A)) :- 
  exists LX. lookup(T,X,LX), 
  exists LA. asec(A, T, LA), 
  le(LA,LX), le(L,LX).

sectyD(L,T,seq(C1,C2)) :- 
  sectyD(L,T,C1),sectyD(L,T,C2).

sectyD(L,T,ift(B,C1,C2)) :- 
  exists Lb. bsec(B,T, Lb),
  le(Lb,L),
  sectyD(L,T, C1),
  sectyD(L,T, C2).

sectyD(L,T,whi(B,C)) :- 
  exists Lb. bsec(B,T, Lb),
  % le(Lb,L), BUG
  sectyD(Lb,T, C). % BUG, was sectyD(L,T,C)

sectyD(L',T,C) :-  
  sectyD(L,T,C),
  le(L', L).

% NF
% tyD-imp-ty
% Checking depth 1 2 3 4 5 6 7
% Total: 0.861369 s:
% C = whi(b(mfalse),assn(X578778,c(sc(z)))) 
% L = sc(sc(sc(sc(sc(sc(z)))))) 
% T = [(X578778,sc(sc(sc(sc(z)))))] 
%                           
% NF without augmented bound
% Checking depth 1 2 3 4 5 6 7 8 9
% Total: 42.495687 s:
% C = whi(b(mfalse),assn(X29278649,c(sc(sc(sc(z)))))) 
% L = sc(sc(sc(sc(sc(sc(sc(sc(z)))))))) 
% T = [(X29278649,z)] 

% NEs
% Checking depth 1 2 3 4 5 6 7 8 9 10 11 12
% Total: 1210.792639 s:
% C = whi(b(N831472804),assn(X831493428,c(N831493451))) 
% L = sc(_831556899) 
% T = [(X831493428,z)|_831493433] 

(*
 Nitpick

     c = WHILE Bc True DO [] ::= N 1
    l = 1 
 *)

