%% Volpano other type systems, from Concrete semantics

% standard type system fig 9.8 with antimono in and max out

pred sectyD (level,sectx,cmd).

sectyD(_,_,skip).

sectyD(L,T,assn(X,A)) :- 
  exists LX. lookup(T,X,LX), 
  exists LA. asec(A, T, LA), 
  le(LA,LX), le(L,LX).

sectyD(L,T,seq(C1,C2)) :- 
  sectyD(L,T,C1),sectyD(L,T,C2).

sectyD(L,T,ift(B,C1,C2)) :- 
  exists Lb. bsec(B,T, Lb),
  le(Lb,L),
  sectyD(L,T, C1),
  sectyD(L,T, C2).

sectyD(L,T,whi(B,C)) :- 
  exists Lb. bsec(B,T, Lb),
  le(Lb,L),
  sectyD(L,T, C).

sectyD(L',T,C) :-  
  exists L. sectyD(L,T,C),
  le(L', L).


%% bottom up typing

% pred sectyBUP (level,sectx,cmd).

% % mode of sectyBUP(-L,+T,C)
% sectyBUP(_,_,skip).


% sectyBUP(LX,T,assn(X,A)) :- 
%   exists LX. lookup(T,X,LX), 
%   exists LA. asec(A, T, LA), 
%   le(LA,LX).

% sectyBUP(LMIN,T,seq(C1,C2)) :- 
%     exists L1. sectyBUP(L1,T,C1),
%     exists L2. sectyBUP(L2,T,C2),
%     min(L1,L2,LMIN).

% sectyBUP(LMIN,T,ift(B,C1,C2)) :- 
%   exists L1. sectyBUP(L1,T, C1),
% 	     exists L2. sectyBUP(L2,T, C2),
% 			exists Max. min(L1,L2,LMIN),
% 				    exists Lb. bsec(B,T, Lb),
% 					       le(Lb,LMIN).
			 


% sectyBUP(L,T,whi(B,C)) :-
%     exists Lb. bsec(B,T, Lb), le(Lb,L),
%     sectyBUP(L,T, C).

